function [h1,h2]=ArrowDrw(x1,y1,p1,w)
%ArrowDrw draw arrow on a graphics window using
%    a mouse.

%  (c) Xue Dingy, 1996, 19 Nov, 1996
%   Dept of Automatic Control, 
%   Northeastern University, PR China
%   email: xued@ramm.neu.edu.cn
if nargin>=2, x=x1; y=y1; end
if nargin<2, w=0.02; end
if nargin<1, p1=pi/9; end
if nargin<=2, [x,y]=ginput(2); end

xa=get(gca,'Xlim'); ya=get(gca,'YLim');
x1=(x-xa(1))/diff(xa);
y1=(y-ya(1))/diff(ya);
theta=atan2(diff(y1),diff(x1));
theta=[theta+p1,theta-p1];
x2=x1(2)-w*cos(theta);
y2=y1(2)-w*sin(theta);
x2=xa(1)+x2*diff(xa);
y2=ya(1)+y2*diff(ya);
xx1=[x(1), x(2), x2(1)]; xx2=[x(2), x2(2)];
yy1=[y(1), y(2), y2(1)]; yy2=[y(2), y2(2)];
h1=line(xx1,yy1); h2=line(xx2,yy2);
nCol=get(gca,'XColor');
set([h1,h2],'Color',nCol);
set(h1,'UserData',[5,[1,1,1],h2]);
set(h2,'UserData',[5,[1,1,1],h1]);
