%LegdProc processing legends on a graphics window

%  (c) Xue Dingy, 1996, 12 Aug, 1997
%   Dept of Automatic Control, 
%   Northeastern University, PR China
%   email: xued@ramm.neu.edu.cn
hLegends=get(gcf,'UserData');

switch nTask
   case 1,
      set(hLegends(1:3),'Visible','on');
   case 2
      iLegends=getlegnd(nTask);
      if length(iLegends)>0
         set(hLegends(1:3),'Visible','on');
         str=get(iLegends,'String');
         set(hLegends(2),'String',str);
      end
   case 3,
      iLegends=getlegnd(nTask);
      if length(iLegends)>0
         set(gcf,'Units','normalized');
         set(gcf,'WindowButtonMotionFcn',...
            ['Pos=get(iLegends,''Position'');',...
             'nXAxis=get(gca,''XLim'');',...
             'nYAxis=get(gca,''YLim'');',...
             'xyPt=get(gcf,''CurrentPoint'');',...
             'Pos(1)=xyPt(1)*diff(nXAxis)+nXAxis(1);',...
             'Pos(2)=xyPt(2)*diff(nYAxis)+nYAxis(1);',...
             'set(iLegends,''Position'',Pos);',...
             'nCol=get(gco,''UserData'');',...
             'set(iLegends,''Color'',nCol(2:4));']);
         set(gcf,'WindowButtonDownFcn',...
            ['set(gcf,''WindowButtonMotionFcn'','''');',...
             'set(gcf,''WindowButtonDownFcn'','''');',...
             'set(gcf,''Units'',''pixels'');']);
      end
   case 4,
      [iLegends,hG]=getlegnd(nTask);
      if length(iLegends)>0, delete(iLegends);
      elseif length(hG)>0, delete(hG); end
   case 5, 
      [x,y,button]=ginput(2);
      if sum(button)==2
         nCol=get(gca,'XColor');
         h=line(x,y); set(h,'Color',nCol);
         set(h,'UserData',[2,nCol]);
      end
   case {6,7}
      if keyFont==1
         bErr=0;
         eval('gFontRotate=eval(get(hFF(13),''String''));','bErr=1;');
         if exist('hFont')
            gFontName=get(hFont,'FontName');
            gFontSize=get(hFont,'FontSize');
            gFontAngle=get(hFont,'FontAngle');
            gFontWeight=get(hFont,'FontWeight');
         end
      end
      if keyStyle1>0
         switch keyStyle1
            case 1, keySign1='-'; 
            case 2, keySign1='--';
            case 3, keySign1=':';
            case 4, keySign1='-.'; 
         end
      end
      if keyStyle2>0,
         keySign2=get(hG,'LineWidth');; 
         if keyStyle2==1, keySign2=0.5*keySign2;
         elseif keyStyle2==2, keySign2=2*keySign2; end
      end
      [ff,kk0]=figflag('Legend Properties',1); delete(kk0);
      if nTask==6
         if length(iLegends)>0, kk=iLegends;
         elseif length(hG)>0, kk=hG; end
      else
         kk=get(gca,'Children'); 
      end
      for i=1:length(kk)
         kk1=get(kk(i),'UserData');
         if length(kk1)>0
            if keyCol==1, 
               set(kk(i),'Color',nCol); 
               hh=get(kk(i),'UserData'); hh(2:4)=nCol;
               set(kk(i),'UserData',hh);
            end
            if keyFont==1 & (kk1(1)==1|kk1(1)==4)
               set(kk(i),'FontName',gFontName);
               set(kk(i),'FontSize',gFontSize);
               set(kk(i),'FontAngle',gFontAngle);
               set(kk(i),'FontWeight',gFontWeight);
               if bErr==0
                  set(kk(i),'Rotation',gFontRotate);
               end
            end
            if keyStyle1>0 & kk1(1)==2,
               set(hG,'LineStyle',keySign1);
            end
            if keyStyle2>0,
               set(hG,'LineWidth',keySign2);
            end
         end
      end
   case 8
      [h1,h2]=arrowdrw;
   case 9
      [ff,kk0]=figflag('Legend Properties',1); delete(kk0);
      kk=get(gca,'Children'); 
      for i=1:length(kk)
         kk1=get(kk(i),'UserData');
         if length(kk1)>0, delete(kk(i)); end
      end
end
