gParWin=figure('Resize','off',...
   'Name','Please Enter Parameters',...
   'NumberTitle','off',...
   'MenuBar','none',...
   'Position',[200,200,300,180]);

hh=axes('Position',[0.001,0.001,0.998,0.998]);
set(hh,'Visible','off');

%%  Define simulation parameters
text(0.05,0.90,'Body Weight (kg)');

hhh(1)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.85 0.2 0.10],...
   'String',num2str(bd_wt),...
   'BackgroundColor',[1,1,1]);
text(0.05,0.75,'Cardiac Output (L min^{-1})');
hhh(2)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.70 0.2 0.10],...
   'Background',[1,1,1],...
   'String',num2str(card_out));
text(0.05,0.60,'Simulation Time (Sec)');
hhh(3)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.55 0.2 0.12],...
   'Background',[1,1,1],...
   'String',num2str(t_f));
text(0.05,0.45,'Total Dose (\mug)');
hhh(4)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.40 0.2 0.12],...
   'Background',[1,1,1],...
   'String',num2str(FenDose));
text(0.05,0.30,'Injection Duration (Sec)');
hhh(5)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.25 0.2 0.12],...
   'Background',[1,1,1],...
   'String',num2str(DoseDur));
text(0.05,0.15,'Calculation Step (Sec)');
hhh(6)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.10 0.2 0.12],...
   'Background',[1,1,1],...
   'String',num2str(DT));
set(gcf,'UserData',hhh);

%%  Execute and Close Window
uicontrol('Style','PushButton',...
   'Unit','normalized',...
   'Position',[0.78,0.75,0.2,0.12],...
   'String','Confirm',...
   'Back',[0.7529,0.7529,0.7529],...
   'CallBack',['h=get(gcf,''UserData'');',...
               'bd_wt=eval(get(hhh(1),''String''));',...
               'card_out=eval(get(hhh(2),''String''));',...
               't_f=eval(get(hhh(3),''String''));',...
               'FenDose=eval(get(hhh(4),''String''));',...
               'DoseDur=eval(get(hhh(5),''String''));',...
               'DT=eval(get(hhh(6),''String''));',...
               'close(gcf); bAlgeModel=0; bFitModel=0; bFigExist=0; keyCtrl=0; ',...
               'T_t=[0; DoseDur; DoseDur+0.001; t_f]/60; ',...
               'U=[1;1;0;0]*FenDose/DoseDur;']);
uicontrol('Style','PushButton',...
   'Unit','normalized',...
   'Position',[0.78,0.55,0.2,0.12],...
   'String','Default',...
   'Back',[0.7529,0.7529,0.7529],...
   'CallBack',['bd_wt=70; card_out=6.48; t_f=21600;',...
               'FenDose=100; DoseDur=60; DT',...
               'close(gcf); bAlgeModel=0; bFitModel=0; bFigExist=0; keyCtrl=0; ',...
               'T_t=[0; DoseDur; DoseDur+0.001; t_f]/60; ',...
               'U=[1;1;0;0]*FenDose/DoseDur;']);
uicontrol('Style','PushButton',...
   'Unit','normalized',...
   'Position',[0.78,0.35,0.2,0.12],...
   'String','Help',...
   'Back',[0.7529,0.7529,0.7529],...
   'CallBack','');

