#include "mex.h"
#include <math.h>
#include "higgins.h"
double nnnn, ttt;
#define min(a , b) ((a) <= (b) ? (a) : (b))

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
   int m, i_count;
   #define Data_IN	 prhs[0]
   #define N_OUT          plhs[0]
   #define Time_OUT       plhs[1]
   #define Lungs_OUT      plhs[2]
   #define Perip_OUT      plhs[3]
   #define Kidney_OUT     plhs[4]
   #define GutSpleen_OUT  plhs[5]
   #define Liver_OUT      plhs[6]
   #define OtherVis_OUT   plhs[7]
   #define Muscle_OUT     plhs[8]
   #define Fat_OUT        plhs[9]
   #define Nasal_OUT      plhs[10]
   #define Brain_OUT      plhs[11]
   #define ImSite_OUT     plhs[12]
   #define Metabolism_OUT plhs[13]
   #define Excretion_OUT  plhs[14]
   #define ArtPool_OUT    plhs[15]
   #define VenPool_OUT    plhs[16]
   #define BldFrac_OUT    plhs[17]
   double *y_N, *y_Time, *y_Lungs, *y_Perip, *y_Kidney, *y_GutSpleen,
       *y_Liver, *y_OtherVis, *y_Muscle, *y_Fat, *y_Nasal,
       *y_Brain, *y_ImSite, *y_Metabolism, *y_Excretion,
       *y_ArtPool, *y_VenPool, *Dat_input, *y_BldFrac;
   allocate_space();
   read_parameters();
   Dat_input = mxGetPr(Data_IN);
   body_weight = Dat_input[0];
   sim_time    = Dat_input[1];
   pend_cycle  = Dat_input[2];
   pend_cardop = Dat_input[3];
   pend_ivdose = Dat_input[4];
   pend_infdur = Dat_input[5];

   m=(int) (sim_time/pend_cycle)+1;
  /* Create matrices for the return argument */
   N_OUT          = mxCreateDoubleMatrix(1,3, mxREAL);
   Time_OUT       = mxCreateDoubleMatrix(m,1, mxREAL);
   Lungs_OUT      = mxCreateDoubleMatrix(m,2, mxREAL);
   Perip_OUT      = mxCreateDoubleMatrix(m,1, mxREAL);
   Kidney_OUT     = mxCreateDoubleMatrix(m,2, mxREAL);
   GutSpleen_OUT  = mxCreateDoubleMatrix(m,3, mxREAL);
   Liver_OUT      = mxCreateDoubleMatrix(m,2, mxREAL);
   OtherVis_OUT   = mxCreateDoubleMatrix(m,2, mxREAL);
   Muscle_OUT     = mxCreateDoubleMatrix(m,3, mxREAL);
   Fat_OUT        = mxCreateDoubleMatrix(m,3, mxREAL);
   Nasal_OUT      = mxCreateDoubleMatrix(m,2, mxREAL);
   Brain_OUT      = mxCreateDoubleMatrix(m,2, mxREAL);
   ImSite_OUT     = mxCreateDoubleMatrix(m,2, mxREAL);
   Metabolism_OUT = mxCreateDoubleMatrix(m,2, mxREAL);
   Excretion_OUT  = mxCreateDoubleMatrix(m,1, mxREAL);
   ArtPool_OUT    = mxCreateDoubleMatrix(m,3, mxREAL);
   VenPool_OUT    = mxCreateDoubleMatrix(m,3, mxREAL);
   BldFrac_OUT    = mxCreateDoubleMatrix(1,11, mxREAL);

  /* Assign pointers to the various parameters */
   y_N = mxGetPr(N_OUT);
   y_Time = mxGetPr(Time_OUT);
   y_Lungs = mxGetPr(Lungs_OUT);
   y_Perip = mxGetPr(Perip_OUT);
   y_Kidney = mxGetPr(Kidney_OUT);
   y_GutSpleen = mxGetPr(GutSpleen_OUT);
   y_Liver = mxGetPr(Liver_OUT);
   y_OtherVis = mxGetPr(OtherVis_OUT);
   y_Muscle = mxGetPr(Muscle_OUT);
   y_Fat = mxGetPr(Fat_OUT);
   y_Nasal = mxGetPr(Nasal_OUT);
   y_Brain = mxGetPr(Brain_OUT);
   y_ImSite = mxGetPr(ImSite_OUT);
   y_Metabolism = mxGetPr(Metabolism_OUT);
   y_Excretion = mxGetPr(Excretion_OUT);
   y_ArtPool = mxGetPr(ArtPool_OUT);
   y_VenPool = mxGetPr(VenPool_OUT);
   y_BldFrac  = mxGetPr(BldFrac_OUT);
   rdnmber_compt = nmber_compt;
   dacon(&protmuc_fr, &protplas_fr);
   pend(artpool_mass, venpool_mass, injpool_mass,rdnmber_compt, protbind_exp);

  do {
      if (iv_dose <= 0.0) dose_increment = 0.0;
      else  dose(&dose_increment);

      if (iv_dose > 0.0) nnnn=iv_dose;

      model(rdnmber_compt, nmber_compt, &total_dose, &aa_mucus, &aabt_mucus);
      pool_drug = artpool_drg + portpool_drg + injpool_drg
             + fatpool_drg + musclpool_drg + venpool_drg;

      tissue_drug = 0.0;
      for (i_count = 0; i_count <= rdnmber_compt - 1; i_count++)
         tissue_drug += tisdrg_equ[i_count];
      temp_main = pool_drug + tissue_drug + cumul_met + cumul_excr + aa_mucus;
      pershunt_drg = blddrg_begequ[PERIPHERAL_SHUNT];
      pershunt_mass = compsvmass_fr[PERIPHERAL_SHUNT];
      blconc();

    //  define return variables in this cycle
      y_Time[cycle_number]=run_time/60;
      y_Lungs[cycle_number] = blddrg_begequ[LUNGS];
      y_Lungs[cycle_number+m] = tisdrg_equ[LUNGS]/tiscompmass_fr[LUNGS];
      y_Perip[cycle_number] = blddrg_begequ[PERIPHERAL_SHUNT];
      y_Kidney[cycle_number] = blddrg_begequ[KIDNEYS];
      y_Kidney[cycle_number+m] = tisdrg_equ[KIDNEYS]/tiscompmass_fr[KIDNEYS];
      y_GutSpleen[cycle_number] = port2pool_drgfr;
      y_GutSpleen[cycle_number+m] = bld_concv[1];
      y_GutSpleen[cycle_number+2*m] = plas_concv[1];
      y_Liver[cycle_number] = blddrg_begequ[LIVER];
      y_Liver[cycle_number+m] = tisdrg_equ[LIVER]/tiscompmass_fr[LIVER];
      y_OtherVis[cycle_number] = blddrg_begequ[OTHER_VISCERA];
      y_OtherVis[cycle_number+m] = tisdrg_equ[OTHER_VISCERA]
                    /tiscompmass_fr[OTHER_VISCERA];
      y_Muscle[cycle_number] = muscl2pool_drgfr;
      y_Muscle[cycle_number+m] = bld_concv[2];
      y_Muscle[cycle_number+2*m] = plas_concv[2];
      y_Fat[cycle_number] = fat2pool_drgfr;
      y_Fat[cycle_number+m] = bld_concv[3];
      y_Fat[cycle_number+2*m] = plas_concv[3];
      y_Nasal[cycle_number] = blddrg_begequ[NASAL_MUCOSAL_SITE];
      y_Nasal[cycle_number+m] = tisdrg_equ[NASAL_MUCOSAL_SITE]
                   /tiscompmass_fr[NASAL_MUCOSAL_SITE];
      y_Brain[cycle_number] = blddrg_begequ[BRAIN];
//      y_Brain[cycle_number+m] = stanconc_old[BRAIN];
      y_Brain[cycle_number+m] = tisdrg_equ[BRAIN]/tiscompmass_fr[BRAIN];
      y_ImSite[cycle_number] = blddrg_begequ[IM_INJECTION_SITE];

      if (cycle_number==0)
      {
         y_Metabolism[cycle_number] = cumul_met;
         y_Excretion[cycle_number] = cumul_excr;
      }
      else
      {
         y_Metabolism[cycle_number] = cumul_met-y_Metabolism[cycle_number-1];
         y_Excretion[cycle_number] = cumul_excr-y_Excretion[cycle_number-1];
      }
      y_ArtPool[cycle_number] = artpool_drg;
      y_VenPool[cycle_number] = venpool_drg;
      y_VenPool[cycle_number+m] = bld_concv[4];
      y_VenPool[cycle_number+2*m] = plas_concv[4];
      y_ArtPool[cycle_number+m] = bld_concv[0];
      y_ArtPool[cycle_number+2*m] = plas_concv[0];
      y_Metabolism[cycle_number+m]=ttt;

      run_time += cycle_time;
      cycle_number++;
  } while ((run_time <= sim_time) & (cycle_number<=m));

  for (i_count=0; i_count<=nmber_compt; i_count++)
     y_BldFrac[i_count]=cardop_fr[i_count];
     y_N[0]=cycle_number--; 
     y_N[1]=nmber_compt; 
     y_N[2]=vsvfr2pool_mass/venpool_mass; 
}

void allocate_space()
{
   tisdrg_begequ = vector(0, 17);
   stanconc_old = vector(0, 17);
   est_stconc = vector(0, 17);
   bldtisdrg_equ = vector(0, 17);
   conc_higgins = vector(0, 17);
   tis2comp_drgfr = vector(0, 17);
   blddrg_begequ = vector(0, 17);
   tisdrg_equ = vector(0, 17);
   b_higgins = vector(0, 17);
   c_higgins = vector(0, 17);
   e_higgins = vector(0, 17);
   x_higgins = vector(0, 17);
   compsvmass_fr = vector(0, 17);
   bld_conc = vector(0, 17);
   plas_conc = vector(0, 17);
   bld_concv = vector(0, 17);
   plas_concv = vector(0, 17);
   tistotmass_fr = vector(0, 17);
   tiscompmass_fr = vector(0, 17);
   cardop_fr = vector(0, 17);
   negoffset_pHt = vector(0, 17);
   negslope_pHt = vector(0, 17);
   celtis_fr = vector(0, 17);
   wattis_fr = vector(0, 17);
   liptis_fr = vector(0, 17);
   prottis_fr = vector(0, 17);
   watecf_fr = vector(0, 17);
   protecf_fr = vector(0, 17);
   lipecf_fr = vector(0, 17);
   celprot_mlms = vector(0, 17);
   watfr_tiscelfr = vector(0, 17);
   lipfr_tiscelfr = vector(0, 17);
   protfr_tiscelfr = vector(0, 17);
   pH_cel = vector(0, 17);
   pH_ecf = vector(0, 17);
}

void read_parameters()
{
   int i;
   nmber_compt = 11;      /* Number of Compartments */
   protbind_exp = 1;      /* protein Binding Expression */
           /* "0": binding of unioneised drug only to protein molecules */
           /* "1": binding of all forms of drug to protein molecules */
   nmb_permixes = 14;     /* Number of calculated Peripheral Mixes */
   acidity = 1.0;         /* Acid or base drug indicator: */
                     /* "1": for basic drug, "-1": for acidic drug */
   pKa = 7.85;               /* fentanyl pKa */
   lipwat_part = 500.0;        /* Lipid-Water partition coefficient */
   urine_pH = 6.2;           /* Urine pH */
   livmetex_fr = 0.55;     /* Liver metabolic extraction fraction */
   pend_ivdose = 100.0;    /* Pending intra-venous drug dose in ugs */
   body_weight = 70.001;    /* Total body weight in Kgs */
   bldtotmass_fr = 0.07857; /* Kg blood / Kg total body mass */
   celbld_fr = 0.45; /* Haematocrit: g cells / g blood; */
                            /* volume of red cells in blood */
   pend_pHplas = 7.40; /* Pending Plasma pH */
   pend_cardop = 6.48; /* Pending cardiac output: litres/min. */
   pend_infdur = 60.0; /* Pending infusion duration in seconds */

   for (i = 0; i <= 6; i++) celtis_fr[i] = 0.80;
   celtis_fr[FAT] = 0.925;       /* Kg cells / Kg of tissue */
   celtis_fr[BRAIN] = 0.70;
   celtis_fr[NASAL_MUCOSAL_SITE] = celtis_fr[IM_INJECTION_SITE] = 0.80;

   artpool_bfr = 0.1300;  /* Fraction of total blood volume: arterial pool */
   fatpool_bfr = 0.1010;   /* Fraction of total blood volume: fat pool */
   injpool_bfr = 0.1300;   /* Fraction of total blood volume: injection-site pool */
   musclpool_bfr = 0.3380; /* Fraction of total blood volume: muscle pool */
   portpool_bfr = 0.1710; /* Fraction of total blood volume: portal pool */
   venpool_bfr = 0.1300;   /* Fraction of total blood volume: venous pool */

   watplas_fr = 0.9155;    /* Kg water / Kg plasma */
   protplas_fr = 0.0680;   /* Kg protein / Kg plasma */
   sim_time = 21600.0;     /* Simulation time in seconds */

   wattis_fr[LUNGS] = 0.7500;
   wattis_fr[PERIPHERAL_SHUNT] = 0.00;
   wattis_fr[KIDNEYS] = 0.7700;
   wattis_fr[GUT_SPLEEN] = 0.7840;
   wattis_fr[LIVER] = 0.7200;
   wattis_fr[OTHER_VISCERA] = 0.7740;  /* Kg water / Kg tissue */
   wattis_fr[MUSCLE] = 0.7470;
   wattis_fr[FAT] = 0.1490;
   wattis_fr[BRAIN] = 0.7900;
   wattis_fr[IM_INJECTION_SITE] = 0.7900;
   wattis_fr[NASAL_MUCOSAL_SITE] = 0.7917;

   liptis_fr[LUNGS] = 0.0120;
   liptis_fr[PERIPHERAL_SHUNT] = 0.00;
   liptis_fr[KIDNEYS] = 0.0520;
   liptis_fr[GUT_SPLEEN] = 0.0570;
   liptis_fr[LIVER] = 0.0670;
   liptis_fr[OTHER_VISCERA] = 0.1050;  /* Kg lipid / Kg tissue */
   liptis_fr[MUSCLE] = 0.0450;
   liptis_fr[FAT] = 0.8000;
   liptis_fr[BRAIN] = 0.1100;
   liptis_fr[IM_INJECTION_SITE] = 0.0200;
   liptis_fr[NASAL_MUCOSAL_SITE] = 0.0617;

   prottis_fr[LUNGS] = 0.1800;
   prottis_fr[PERIPHERAL_SHUNT] = 0.00;
   prottis_fr[KIDNEYS] = 0.1700;
   prottis_fr[GUT_SPLEEN] = 0.1410;
   prottis_fr[LIVER] = 0.1800;
   prottis_fr[OTHER_VISCERA] = 0.0970;  /* Kg protein / Kg tissue */
   prottis_fr[MUSCLE] = 0.1910;
   prottis_fr[FAT] = 0.0490;
   prottis_fr[BRAIN] = 0.0800;
   prottis_fr[IM_INJECTION_SITE] = 0.1700;
   prottis_fr[NASAL_MUCOSAL_SITE] = 0.1333;

   tistotmass_fr[LUNGS] = 0.006628;
   tistotmass_fr[PERIPHERAL_SHUNT] = 0.00;
   tistotmass_fr[KIDNEYS] = 0.004057;
   tistotmass_fr[GUT_SPLEEN] = 0.0198700;
   tistotmass_fr[LIVER] = 0.02459;
   tistotmass_fr[OTHER_VISCERA] = 0.02686; /* Kg tissue / Kg total mass */
   tistotmass_fr[MUSCLE] = 0.52446;
   tistotmass_fr[FAT] = 0.19557;
   tistotmass_fr[BRAIN] = 0.00010;
   tistotmass_fr[IM_INJECTION_SITE] = 0.00014;
   tistotmass_fr[NASAL_MUCOSAL_SITE] = 0.0001186;

   watecf_fr[LUNGS] = 0.9650;
   watecf_fr[PERIPHERAL_SHUNT] = 0.9650;
   watecf_fr[KIDNEYS] = 0.9650;
   watecf_fr[GUT_SPLEEN] = 0.9650;
   watecf_fr[LIVER] = 0.9650;
   watecf_fr[OTHER_VISCERA] = 0.9650;  /* Kg water / Kg ecf */
   watecf_fr[MUSCLE] = 0.9650;
   watecf_fr[FAT] = 0.9650;
   watecf_fr[BRAIN] = 0.9900;
   watecf_fr[IM_INJECTION_SITE] = 0.9650;
   watecf_fr[NASAL_MUCOSAL_SITE] = 0.9650;

   for (i = 0; i <= 10; i++) lipecf_fr[i] = 0.0;   /* Kg lipid / Kg ecf */

   protecf_fr[LUNGS] = 0.0350;
   protecf_fr[PERIPHERAL_SHUNT] = 0.0350;
   protecf_fr[KIDNEYS] = 0.0350;
   protecf_fr[GUT_SPLEEN] = 0.0350;
   protecf_fr[LIVER] = 0.0350;
   protecf_fr[OTHER_VISCERA] = 0.0350;  /* Kg protein / Kg ecf */
   protecf_fr[MUSCLE] = 0.0350;
   protecf_fr[FAT] = 0.0350;
   protecf_fr[BRAIN] = 0.0100;
   protecf_fr[IM_INJECTION_SITE] = 0.0350;
   protecf_fr[NASAL_MUCOSAL_SITE] = 0.0350;

   cardop_fr[LUNGS] = 1.0;
   cardop_fr[PERIPHERAL_SHUNT] = 0.151 * (1.0 / 1.00162);
   cardop_fr[KIDNEYS] = 0.188 * (1.0 / 1.00162);
   cardop_fr[GUT_SPLEEN] = 0.171 * (1.0 / 1.00162);
   cardop_fr[LIVER] = 0.0690 * (1.0 / 1.00162);
   cardop_fr[OTHER_VISCERA] = 0.191 * (1.0 / 1.00162);
   cardop_fr[MUSCLE] = 0.17690 * (1.0 / 1.00162);        /* Fractional stroke volumes */
   cardop_fr[FAT] = 0.05300 * (1.0 / 1.00162);           /* correction factor to make */
   cardop_fr[BRAIN] = 0.00105 * (1.0 / 1.00162);         /* sum = 1.0 */
   cardop_fr[IM_INJECTION_SITE] = 0.00003 * (1.0 / 1.00162);
   cardop_fr[NASAL_MUCOSAL_SITE] = 0.000640 * (1.0 / 1.00162);

   negoffset_pHt[LUNGS] = -0.40;
   negoffset_pHt[PERIPHERAL_SHUNT] = 0.00;
   negoffset_pHt[KIDNEYS] = -0.30;
   negoffset_pHt[GUT_SPLEEN] = -0.60;
   negoffset_pHt[LIVER] = -0.30;
   negoffset_pHt[OTHER_VISCERA] = -0.60;  /* Negative offset pH equation for */
   negoffset_pHt[MUSCLE] = -0.46;         /* compartment tissues */
   negoffset_pHt[FAT] = -0.20;
   negoffset_pHt[BRAIN] = -0.30;
   negoffset_pHt[IM_INJECTION_SITE] = -0.46;
   negoffset_pHt[NASAL_MUCOSAL_SITE] = -0.30;

   negslope_pHt[LUNGS] = -0.80;
   negslope_pHt[PERIPHERAL_SHUNT] = 0.00;
   negslope_pHt[KIDNEYS] = -0.80;
   negslope_pHt[GUT_SPLEEN] = -0.80;
   negslope_pHt[LIVER] = -0.80;
   negslope_pHt[OTHER_VISCERA] = -0.80;  /* Negative slope pH equation for */
   negslope_pHt[MUSCLE] = -0.80;         /* for compartment tissue */
   negslope_pHt[FAT] = -0.80;
   negslope_pHt[BRAIN] = -0.80;
   negslope_pHt[IM_INJECTION_SITE] = -0.80;
   negslope_pHt[NASAL_MUCOSAL_SITE] = -0.80;

   pend_cycle = 1.0;       /* Pending cycle-time in seconds */
   plasprot_mlms = 91000.0; /* Mean molar mass of plasma proteins in g */
   ecfprot_mlms = 91000.0;   /* Mean molar mass of ecf proteins in g */

   celprot_mlms[LUNGS] = 91000.0;
   celprot_mlms[PERIPHERAL_SHUNT] = 0.0;
   celprot_mlms[KIDNEYS] = 91000.0;
   celprot_mlms[GUT_SPLEEN] = 91000.0;
   celprot_mlms[LIVER] = 91000.0;
   celprot_mlms[OTHER_VISCERA] = 91000.0;
   celprot_mlms[MUSCLE] = 91000.0;  /* Mean molar mass of cell proteins */
   celprot_mlms[FAT] = 91000.0;     /* in g */
   celprot_mlms[BRAIN] = 91000.0;
   celprot_mlms[IM_INJECTION_SITE] = 91000.0;
   celprot_mlms[NASAL_MUCOSAL_SITE] = 91000.0;

//
// Initialisation of the variables which are unique to "fentanyl"
//
   urine_flow = 100.0;         /* urine water output g/h */
   urine_concfct = 17.0;     /* urine concentration factor */
   wt_muc = 4.0 / 10000.0;   /* Kg mucous in nasal absorption site */
   protmuc_fr = 6.77 / 1000.0;   /* Kg protein / Kg mucous */
   watmuc_fr = 0.94;    /* Kg water / Kg mucous */
   nasal_pH = 6.0;     /* pH nasal secretions */
   mucprot_mlms = 91000.0;   /* average molecular weight for mucous proteins */
   erythplas_ratio = 0.908;   /* erythrocyte-plasma ratio */
              /* umol per Kg eryth / umol drug per Kg plasma */
   protbnd_cnstif = 0.001246;  /* protein binding constant ionised form */
   protbnd_cnstuf = 0.019121;  /* protein binding constant unionised form */

/**************************************************************************/
/*     Also hard-wired in the program are:                                */
/*      - the density of blood: 1.06 g/ml                                 */
/*      - the density of plasma: 1.03 g/ml                                */
/*      - the density of erythrocytes: 1.10 g/ml                          */
/*      - conversion coefficient from "ug" to "umoles": 1.0 / 336.60      */
/**************************************************************************/
}

void dose (double *dose_increment)
{
   //
   // Store the intra-venous dose in a temporary variable.
   //
   double temp_dose = iv_dose;
   //
   // If the cycle-time is greater than the remainingiv-dose duration, or if the 
   // previous dose increment is greater than the remaining iv-dose, set the dose-
   // increment to the remaining iv-value, otherwise calculate the dose increment.
   //
   if (cycle_time > inf_duration || *dose_increment > iv_dose) *dose_increment = iv_dose;
   else *dose_increment = (iv_dose * cycle_time) / inf_duration;
   //
   // Update the iv-dose for next cycle.
   //
   iv_dose -= *dose_increment;
   //
   // If as a result of above and the possible change in the cycle time the iv-dose is 
   // negative, set the dose-increment to the remaining iv-dose and the iv-dose to zero.
   //
   if (iv_dose < 0.0) {
      *dose_increment = temp_dose;  iv_dose = 0.0;
   }
   //
   // Infusion duration id decremented by the cycle time.
   //
   inf_duration -= cycle_time;
}

void lamset(int rdnmber_compt, int protbind_exp)
{
   int i;

   if (protbind_exp > 0) {
      R_plas = (pow(10.0, acidity * (pKa - pH_plas)));
      R_mucus = (pow(10.0, acidity * (pKa - nasal_pH)));
      m_higgins = wt_muc * (watmuc_fr * (1.0 + R_mucus) + protmuc_fr * (protbnd_cnstuf + (protbnd_cnstif * R_mucus)));
      for (i = 0; i <= rdnmber_compt - 1; i++) {
         R_ecf = (pow(10.0, acidity * (pKa - pH_ecf[i])));
         x_higgins[i] = (pow(10.0, acidity * (pKa - pH_cel[i])));
         b_higgins[i] = (celbld_fr * (erythplas_ratio - 1.0) + 1.0)
              * (protplas_fr * (protbnd_cnstuf + protbnd_cnstif * R_plas)
              + watplas_fr * (1.0 + R_plas));
         c_higgins[i] = celtis_fr[i] * ((lipfr_tiscelfr[i] * lipwat_part)
              + (protfr_tiscelfr[i] * (protbnd_cnstuf + protbnd_cnstif * x_higgins[i]))
              + watfr_tiscelfr[i] * (x_higgins[i] + 1.0));
         e_higgins[i] = (1.0 - celtis_fr[i]) * (protecf_fr[i] * (protbnd_cnstuf + (protbnd_cnstif * R_ecf))
              + watecf_fr[i] * (1.0 + R_ecf));
      }
   }
   else {
      R_plas = R_ecf = R_mucus = 1.0;
      for (i = 0; i <= rdnmber_compt - 1; i++)
         x_higgins[i] = b_higgins[i] = c_higgins[i] = e_higgins[i] = 1.0;
   }
}

void equilibrate(int rdnmber_compt, double *aa_mucus, double *aabt_mucus)
{
   int i;
   for (i = 0; i <= rdnmber_compt - 1; i++) {
      stanconc_old[i] = conc_higgins[i];
      tisdrg_begequ[i] = tisdrg_equ[i];
   }
   for (i = 0; i <= rdnmber_compt - 1; i++) {
      switch (i) {
         case PERIPHERAL_SHUNT:
              blddrg_begequ[i] = tis2comp_drgfr[i];
              tisdrg_equ[i] = 0.0;
              bldtisdrg_equ[i] = tis2comp_drgfr[i];
              conc_higgins[i] = tis2comp_drgfr[i] / (compsvmass_fr[i] * b_higgins[i]);
              break;
         case NASAL_MUCOSAL_SITE:
              *aabt_mucus = tis2comp_drgfr[i] + tisdrg_equ[i] + *aa_mucus;
              conc_higgins[i] = *aabt_mucus / ((compsvmass_fr[i] * b_higgins[i])
                  + tiscompmass_fr[i] * (e_higgins[i] + c_higgins[i])+ m_higgins);
              blddrg_begequ[i] = conc_higgins[i] * compsvmass_fr[i] * b_higgins[i];
              tisdrg_equ[i] = conc_higgins[i] * tiscompmass_fr[i] * (e_higgins[i] + c_higgins[i]);
              *aa_mucus = conc_higgins[i] * m_higgins;
              bldtisdrg_equ[i] = blddrg_begequ[i] + tisdrg_equ[i];
              break;
         case KIDNEYS:
              bldtisdrg_equ[i] = tis2comp_drgfr[i] + tisdrg_equ[i];
              b_higgins[i] /= urine_concfct;
              c_higgins[i] /= urine_concfct;
              e_higgins[i] /= urine_concfct;
              conc_higgins[i] = bldtisdrg_equ[i] / ((compsvmass_fr[i] * b_higgins[i])
                   + (tiscompmass_fr[i] * (c_higgins[i] + e_higgins[i])) + u_higgins);
              blddrg_begequ[i] = conc_higgins[i] * compsvmass_fr[i] * b_higgins[i];
              tisdrg_equ[i] = conc_higgins[i] * tiscompmass_fr[i] * (c_higgins[i] + e_higgins[i]);
              conc_higgins[i] /= urine_concfct;
              b_higgins[i] *= urine_concfct;
              c_higgins[i] *= urine_concfct;
              e_higgins[i] *= urine_concfct;
              break;
         default:
              bldtisdrg_equ[i] = tis2comp_drgfr[i] + tisdrg_equ[i];
              conc_higgins[i] = bldtisdrg_equ[i] / ((compsvmass_fr[i] * b_higgins[i])
                   + (tiscompmass_fr[i] * (c_higgins[i] + e_higgins[i])));
              blddrg_begequ[i] = conc_higgins[i] * compsvmass_fr[i] * b_higgins[i];
              tisdrg_equ[i] = conc_higgins[i] * tiscompmass_fr[i] * (c_higgins[i] + e_higgins[i]);
              break;
      }
   }
}

void model(int rdnmber_compt, int nmber_compt, double *total_dose,
         double *aa_mucus, double *aabt_mucus)
{
   int i;
   double temp = 0.0;
   //
   // Calculate fractions of stroke volume mass to all compartments.
   //
   for (i = 0; i <= rdnmber_compt - 1; i++)
        compsvmass_fr[i] = cardop_fr[i] * stroke_volweight;
   //
   // Calculate masses of fractions of stroke-volume (svw) to pools.
   //
   vsvfr2pool_mass = stroke_volweight;
   msvfr2pool_mass = compsvmass_fr[MUSCLE];
   fsvfr2pool_mass = compsvmass_fr[FAT];
   psvfr2pool_mass = compsvmass_fr[GUT_SPLEEN];
   //
   // Calculate the amounts of drug in svw fractions to compartments (in micro-moles).
   //
   for (i = 0; i <= rdnmber_compt - 1; i++) {
      if (i == LUNGS) tis2comp_drgfr[LUNGS] = (compsvmass_fr[LUNGS] / injpool_mass) * injpool_drg;
      else tis2comp_drgfr[i] = (compsvmass_fr[i] / artpool_mass) * artpool_drg;
   }
   //
   // Calculate the amounts of drug in svw fractions to pools (in micromoles).
   //
   ven2pool_drgfr = (vsvfr2pool_mass / venpool_mass) * venpool_drg;
   port2pool_drgfr = (psvfr2pool_mass / portpool_mass) * portpool_drg;
   muscl2pool_drgfr = (msvfr2pool_mass / musclpool_mass) * musclpool_drg;
   fat2pool_drgfr = (fsvfr2pool_mass / fatpool_mass) * fatpool_drg;
   //
   // Calculate the amounts of drug remaining in the pools (in micromoles).
   //
   portpool_drg -= port2pool_drgfr;
   musclpool_drg -= muscl2pool_drgfr;
   fatpool_drg -= fat2pool_drgfr;
   venpool_drg -= ven2pool_drgfr;
   injpool_drg -= tis2comp_drgfr[LUNGS];
   //
   // Calculate the amounts of drug remaining in the arterial pool (in micromoles).
   //
   for (i = 1; i <= rdnmber_compt - 1; i++) artpool_drg -= tis2comp_drgfr[i];
   //
   // Combine the portal pool with the liver in terms of fractions of stroke-volume 
   // mass and the amount of drug in the liver (in micromoles).
   //
   compsvmass_fr[LIVER] += psvfr2pool_mass;
   tis2comp_drgfr[LIVER] += port2pool_drgfr;
   //
   // Store the amount of drug in the "liver" in a temporary storage.
   //
   temp = tis2comp_drgfr[LIVER];
   //
   // remove the excreted drug from the blood entering the liver.
   //
   tis2comp_drgfr[LIVER] = tis2comp_drgfr[LIVER] * (1.0 - livmetex_fr);
   //
   // Keep record of the cumulative dose metabolised in the liver.
   //
   cumul_met += (temp - tis2comp_drgfr[LIVER]);
   //
   // Equilibrate tissue-drug with blood-drug in all tissue compartments.
   //
   equilibrate(rdnmber_compt, aa_mucus, aabt_mucus);
   //
   // Keep record of the cumulative dose excreted from the kidneys.
   //
   cumul_excr += (conc_higgins[KIDNEYS] * u_higgins * urine_concfct);
   //
   // Once equilibration is achieved update the drug amounts in pools by addition of
   // incoming fractions; sample brain and intra-muscular injection site included if need be.
   //
   artpool_drg += blddrg_begequ[LUNGS];
   portpool_drg += blddrg_begequ[GUT_SPLEEN];
   musclpool_drg += blddrg_begequ[MUSCLE];
   fatpool_drg += blddrg_begequ[FAT];
   injpool_drg += ven2pool_drgfr;
   venpool_drg += muscl2pool_drgfr + fat2pool_drgfr
         + blddrg_begequ[PERIPHERAL_SHUNT] + blddrg_begequ[KIDNEYS]
         + blddrg_begequ[LIVER] + blddrg_begequ[OTHER_VISCERA];
   if (rdnmber_compt >= (nmber_compt - 1)) {
      for (i = nmber_compt - 3; i <= rdnmber_compt - 1; i++)
         venpool_drg += blddrg_begequ[i];
   }
   //
   // Administers the intra-muscular dose as one increment to the intra-muscular injection site.
   //
   if (im_dose > 0.0) {
      tisdrg_equ[IM_INJECTION_SITE] += im_dose;
      *total_dose += im_dose;
      im_dose = 0.0;
   }
   //
   // Administers the intra-pulmonary dose as one increment to the lungs compartment.
   //
   if (ip_dose > 0.0) {
      tisdrg_equ[LUNGS] += ip_dose;
      *total_dose += ip_dose;
      ip_dose = 0.0;
   }
   //
   // Administers the iv dose increment to the injection pool.
   //
   injpool_drg += dose_increment;
   //
   // Update the total dose administered.
   //
   *total_dose += dose_increment;
}

void pend(double artpool_mass, double venpool_mass,
	  double injpool_mass, int rdnmber_compt, int protbind_exp)
{
   int i;
   double temp;
   //
   // Convert micrograms of iv-injected pethidine HCL to micromoles.
   //
   if (pend_ivdose > 0.0) {
      iv_dose = (pend_ivdose * 1.0) / (336.60);
      pend_ivdose = 0.0;
   }
   //
   // Convert micrograms of intra-muscular injected fentanyl to micromoles.
   //
   if (pend_imdose > 0.0 && pend_ivdose <= 0.0) {
      im_dose = pend_imdose / 336.60;
      pend_imdose = 0.0;
   }
   //
   // Convert micrograms of intra-pulmonary injected fentanyl to micromoles.
   //
   if (pend_ipdose > 0.0 && pend_ivdose <= 0.0 && pend_imdose <= 0.0) {
      ip_dose = pend_ipdose / 336.60;
      pend_ipdose = 0.0;
   }
   if (pend_infdur > 0.0) inf_duration = pend_infdur;
   if (pend_pHplas > 0.0) {
      pH_plas = pend_pHplas;
      for (i = 0; i <= rdnmber_compt - 1; i++) {
         if (i != 1) {
            pH_ecf[i] = pH_plas;
            pH_cel[i] = pH_ecf[i] + negoffset_pHt[i] + (negslope_pHt[i] * (pH_ecf[i] - 7.4));
         }
      }
      pH_ecf[PERIPHERAL_SHUNT] = 0.0;
      pH_cel[PERIPHERAL_SHUNT] = 0.0;
      lamset(rdnmber_compt, protbind_exp);
   }
   //
   // Check for pending cycle-time(s) and cardiac output(s).
   //
   if (pend_cycle > 0.0) cycle_time = pend_cycle;
   if (pend_cardop > 0.0) stroke_volweight = pend_cardop * (1.06/ 60.0) * cycle_time;
   //
   // If either cycle-time or cardiac output change test the svw against the smallest 
   // of the three blood pools in order to avoid pulling a volume fraction of blood 
   // which is larger than is physically possible.
   //
   if ((pend_cycle > 0.0 || pend_cardop > 0.0)
         && (((min(min(injpool_mass, artpool_mass), min(venpool_mass, stroke_volweight)))) != stroke_volweight)) {
      cycle_time = (min(min(injpool_mass, artpool_mass), min(venpool_mass, stroke_volweight)))
            * (1.0 /(pend_cardop * (1.06/ 60.0)));
      i = cycle_time;
      if ((cycle_time - i) >= 0.50) cycle_time = i + 1.0;
      else  cycle_time = i;
   }
   temp = (cycle_time * urine_flow) / (1000.0 * 60.0 * 60.0);
   u_higgins = temp * (1.0 + pow(10.0, acidity * (pKa - urine_pH)));
}

void dacon(double *protmuc_fr, double *protplas_fr)
{
   int i;
   //
   // Calculate the mass of blood from the total body mass.
   //
   blood_weight = body_weight * bldtotmass_fr;
   //
   // Calculate tissue compartment masses.
   //
   for (i = 0; i <= rdnmber_compt - 1; i++) tiscompmass_fr[i] = body_weight * tistotmass_fr[i];
   //
   // Calculate the blood pool masses.
   //
   artpool_mass = artpool_bfr * blood_weight;
   portpool_mass = portpool_bfr * blood_weight;
   musclpool_mass = musclpool_bfr * blood_weight;
   fatpool_mass = fatpool_bfr * blood_weight;
   venpool_mass = venpool_bfr * blood_weight;
   injpool_mass = injpool_bfr * blood_weight;
   //
   // Calculate the water, fat and protein fractions in the tissue cell fraction, then convert
   // the protein-cell and protein-ecf fractions to micro-moles of protein for each compartment.
   //
   for (i = 0; i <= rdnmber_compt - 1; i++) {
      if (i != PERIPHERAL_SHUNT) {
         watfr_tiscelfr[i] = (wattis_fr[i] - (watecf_fr[i] * (1.0 - celtis_fr[i]))) / (celtis_fr[i]);
         lipfr_tiscelfr[i] = (liptis_fr[i] - (lipecf_fr[i] * (1.0 - celtis_fr[i]))) / (celtis_fr[i]);
         protfr_tiscelfr[i] = (prottis_fr[i] - (protecf_fr[i] * (1.0 - celtis_fr[i]))) / (celtis_fr[i]);
         protecf_fr[i] = (protecf_fr[i] / ecfprot_mlms) * (pow(10.0, 9.0));
         protfr_tiscelfr[i] = (protfr_tiscelfr[i] / celprot_mlms[i]) * (pow(10.0, 9.0));
      }
   }
   watfr_tiscelfr[PERIPHERAL_SHUNT] = 0.0;
   lipfr_tiscelfr[PERIPHERAL_SHUNT] = 0.0;
   protfr_tiscelfr[PERIPHERAL_SHUNT] = 0.0;
   protecf_fr[PERIPHERAL_SHUNT] = 0.0;
   *protmuc_fr = (*protmuc_fr / mucprot_mlms) * (pow(10, 9));
   *protplas_fr = (*protplas_fr / plasprot_mlms) * (pow(10, 9));
}

void blconc()
{
   int i;
   float temp1, temp2, temp3;

   bld_conc[ARTERIAL_POOL] = artpool_drg / artpool_mass;
   bld_conc[PORTAL_POOL] = portpool_drg / portpool_mass;
   bld_conc[MUSCLE_POOL] = musclpool_drg / musclpool_mass;
   bld_conc[FAT_POOL] = fatpool_drg / fatpool_mass;
   bld_conc[VENOUS_POOL] = venpool_drg / venpool_mass;
   bld_conc[INJECTION_POOL] = injpool_drg / injpool_mass;
   bld_conc[PERIPHERAL_S_POOL] = pershunt_drg / pershunt_mass;

   bld_conc[FIRST_VENOUS_MIX] = (1.0 / 3.0) * bld_conc[PERIPHERAL_S_POOL]
                  + (1.0 / 3.0) * bld_conc[MUSCLE_POOL]
                  + (1.0 / 3.0) * bld_conc[FAT_POOL];
   if (nmb_permixes > 8) {
       bld_conc[SECOND_VENOUS_MIX] = (1.0 / 5.0) * bld_conc[PERIPHERAL_S_POOL]
                  + (2.0 / 5.0) * bld_conc[MUSCLE_POOL]
                  + (2.0 / 5.0) * bld_conc[FAT_POOL];
       bld_conc[THIRD_VENOUS_MIX] = (2.0 / 5.0) * bld_conc[PERIPHERAL_S_POOL]
                  + (1.0 / 5.0) * bld_conc[MUSCLE_POOL]
                  + (2.0 / 5.0) * bld_conc[FAT_POOL];
       bld_conc[FOURTH_VENOUS_MIX] = (2.0 / 5.0) * bld_conc[PERIPHERAL_S_POOL]
                  + (2.0 / 5.0) * bld_conc[MUSCLE_POOL]
                  + (1.0 / 5.0) * bld_conc[FAT_POOL];
       bld_conc[FIFTH_VENOUS_MIX] = (1.0 / 2.0) * bld_conc[PERIPHERAL_S_POOL]
                  + (1.0 / 4.0) * bld_conc[MUSCLE_POOL]
                  + (1.0 / 4.0) * bld_conc[FAT_POOL];
       bld_conc[SIXTH_VENOUS_MIX] = (1.0 / 4.0) * bld_conc[PERIPHERAL_S_POOL]
                  + (1.0 / 2.0) * bld_conc[MUSCLE_POOL]
                  + (1.0 / 4.0) * bld_conc[FAT_POOL];
       bld_conc[SEVENTH_VENOUS_MIX] = (1.0 / 4.0) * bld_conc[PERIPHERAL_S_POOL]
                  + (1.0 / 4.0) * bld_conc[MUSCLE_POOL]
                  + (1.0 / 2.0) * bld_conc[FAT_POOL];
   }
   temp1 = (erythplas_ratio * celbld_fr) + (1.0 - celbld_fr);
   temp2 = protplas_fr * (protbnd_cnstuf + (protbnd_cnstif * R_plas));
   temp3 = watplas_fr * (1.0 + R_plas);
   for (i = 0; i <= nmb_permixes - 1; i++) {
      est_stconc[i] = bld_conc[i] / (temp1 * (temp2 + temp3));
      plas_conc[i] =  bld_conc[i] / temp1;
   }
   ttt=temp1;
   for (i = 0; i <= nmb_permixes - 1; i++) {
      bld_concv[i] = bld_conc[i] * 1.06;
      plas_concv[i] = plas_conc[i] * 1.03;
   }
}

