pause(0.0001);
waitmsg('Identifying models, please wait...');
pause(0.0001);
t_Alge=t; 

%set the calculation step as the sampling interval (in minutes)
T=DT/60;

%now fitting the 2nd order Fat model
u= ArtPool(:,1);  y= Fat(:,1);  
th=arx([y,u],[2,2,1]);  G=tf(th); G=G(1); G.Ts=T; G_Fat=d2c(G);
% [nn,dd]=th2tf(th); [n_Fat,d_Fat]=tfd2c(nn,dd,T);
%   G_Fat=tf(n_Fat,d_Fat);
u=Fat(:,2); K_Fat=sum(u.*y)/sum(y.*y); 
[n_Fat,d_Fat]=tfdata(G_Fat,'v');  

%now fitting the second order Lungs model
ii=find(t_Alge<=DoseDur/60);
u=Perip(:,1)+Kidneys(:,1)+Liver(:,1)+Fat(:,1)+Muscle(:,1)+...
      OtherVis(:,1)+Nasal(:,1)+Brain(:,1)+ImSite(:,1);
y=VenPool(:,2); K_VenPool=sum(u.*y)/sum(u.*u);
u(ii)=u(ii)+FenDose/(DoseDur*336.6);
y=ArtPool(:,1); th=arx([y,u],[2,2,1]); 
G=tf(th); G=G(1); G.Ts=T; G_Lungs=d2c(G);
%[nn,dd]=th2tf(th); [n_Lungs,d_Lungs]=tfd2c(nn,dd,T);
u=Lungs(:,2); K_Lungs=sum(u.*y)/sum(y.*y);
[n_Lungs,d_Lungs]=tfdata(G_Lungs,'v');  
   
%now fitting the 2nd order Gut Spleen model
u= ArtPool(:,1);  %input to the gut spleen
y=GutSpleen(:,1); 
th=arx([y,u],[2,2,1]);
G=tf(th); G=G(1); G.Ts=T; G_Gut=d2c(G);
u=GutSpleen(:,2); K_Gut=sum(u.*y)/sum(y.*y);
[n_Gut,d_Gut]=tfdata(G_Gut,'v');  

%now fitting the first order other viscera model
u=ArtPool(:,1);  y=OtherVis(:,1);
th=arx([y,u],[1,1,1]);
G=tf(th); G=G(1); G.Ts=T; G_OtherVis=d2c(G);
u=OtherVis(:,2); K_OtherVis=sum(u.*y)/sum(y.*y);
[n_OtherVis,d_OtherVis]=tfdata(G_OtherVis,'v');  

%now fitting the second order muscle model
u=ArtPool(:,1); y=Muscle(:,1);
th=arx([y,u],[2,2,1]);
G=tf(th); G=G(1); G.Ts=T; G_Muscle=d2c(G);
u=Muscle(:,2); K_Muscle=sum(u.*y)/sum(y.*y);
[n_Muscle,d_Muscle]=tfdata(G_Muscle,'v');  

% now fitting the first order Nasal model
u=ArtPool(:,1);  y=Nasal(:,1); 
th=arx([y,u],[1,1,1]);
G=tf(th); G=G(1); G.Ts=T; G_Nasal=d2c(G);
u=Nasal(:,2); K_Nasal=sum(u.*y)/sum(y.*y);
[n_Nasal,d_Nasal]=tfdata(G_Nasal,'v');  
   
% now fitting the first order Brain model
u= ArtPool(:,1);  y=Brain(:,1); 
th=arx([y,u],[1,1,1]);
G=tf(th); G=G(1); G.Ts=T; G_Brain=d2c(G);
u=Brain(:,2); K_Brain=sum(u.*y)/sum(y.*y);
[n_Brain,d_Brain]=tfdata(G_Brain,'v');  

% now fitting the first order Kidneys model
u=ArtPool(:,1); y=Kidneys(:,1); 
th=arx([y,u],[1,1,1]);
G=tf(th); G=G(1); G.Ts=T; G_Kidneys=d2c(G);
u=Kidneys(:,2); K_Kidneys=sum(u.*y)/sum(y.*y);

% now fitting the first order Liver model
K_l=BldFrac(5);
u=K_l*ArtPool(:,1)+GutSpleen(:,1);  y=Liver(:,1);
th=arx([y,u],[1,1,1]);
G=tf(th); G=G(1); G.Ts=T; G_Liver=d2c(G);
u=Liver(:,2); K_Liver=sum(u.*y)/sum(y.*y);

% now fitting the peripheral shunt ratio
u=ArtPool(:,1); y=Perip(:,1); K_p=sum(y.*u)/sum(u.*u);
y=ArtPool(:,2); K_ArtPool=sum(u.*y)/sum(u.*u);

%now fitting the second order Lungs model
ii=find(t_Alge<=DoseDur/60);
u=Perip(:,1)+Kidneys(:,1)+Liver(:,1)+Fat(:,1)+Muscle(:,1)+...
      OtherVis(:,1)+Nasal(:,1)+Brain(:,1)+ImSite(:,1);
y=VenPool(:,2); K_VenPool=sum(u.*y)/sum(u.*u);
u(ii)=u(ii)+FenDose/(DoseDur*336.6);
y=ArtPool(:,1); th=arx([y,u],[2,2,1]);
G=tf(th); G=G(1); G.Ts=T; G_Lungs=d2c(G);
u=Lungs(:,2); K_Lungs=sum(u.*y)/sum(y.*y);

K_Opts=[K_Kidneys; K_Liver; K_GutSpleen; K_OtherVis; K_Muscle; ...
      K_Fat; K_Brain; K_Nasal; K_VenPool; K_ArtPool; K_Lungs];
pause(0.0001);
delete(gcf);
