gGPCWin=figure('Resize','off',...
   'Name','NL GPC Control',...
   'NumberTitle','off',...
   'MenuBar','none',...
   'Position',[200,100,350,220]);

hh=axes('Position',[0.001,0.001,0.998,0.998]);
set(hh,'Visible','off');

%%  Define simulation parameters
text(0.05,0.90,'Input weighting \lambda');
hhh(1)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.45 0.85 0.2 0.08],...
   'String',num2str(nn_lambda),...
   'BackgroundColor',[1,1,1]);

text(0.05,0.77,'Input u_{max} (\mug sec^{-1})');
hhh(2)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.45 0.72 0.2 0.08],...
   'String',num2str(nn_umax),...
   'BackgroundColor',[1,1,1]);

text(0.05,0.64,'points of simulation');
hhh(3)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.45 0.59 0.2 0.08],...
   'String',num2str(nn_simpoints),...
   'BackgroundColor',[1,1,1]);

text(0.05,0.51,'noise level \gamma_n');
hhh(4)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.45 0.46 0.2 0.08],...
   'String',num2str(nn_gamma_n),...
   'BackgroundColor',[1,1,1]);

text(0.05,0.38,'System EC_{50} (ng ml^{-1})');
hhh(5)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.45 0.33 0.2 0.08],...
   'String',num2str(nn_ie50),...
   'BackgroundColor',[1,1,1]);

text(0.05,0.25,'System steepness \gamma');
hhh(6)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.45 0.20 0.2 0.08],...
   'String',num2str(nn_gamma),...
   'BackgroundColor',[1,1,1]);

text(0.05,0.13,'Filter polynomial');
hhh(7)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.40 0.07 0.5 0.08],...
   'String',['[' num2str(nn_TFilter) ']'],...
   'BackgroundColor',[1,1,1]);

text(0.70,0.6,'Plant model');
hhh(8)=uicontrol('Style','ListBox',...
   'Unit','normalized',...
   'Position',[0.68 0.42 0.30 0.12],...
   'String','Linear Model | Alge Model',...
   'BackgroundColor',[1,1,1]);

set(gcf,'UserData',hhh);
uicontrol('Style','PushButton',...
   'Unit','normalized',...
   'Position',[0.73,0.82,0.2,0.11],...
   'String','Control',...
   'Back',[0.7529,0.7529,0.7529],...
   'CallBack',['hhh=get(gcf,''UserData'');',...
      'nn_lambda=eval(get(hhh(1),''String''));',...
      'nn_umax=eval(get(hhh(2),''String''));',...
      'nn_simpoints=eval(get(hhh(3),''String''));',...
      'nn_gamma_n=eval(get(hhh(4),''String''));',...
      'nn_ie50=eval(get(hhh(5),''String''));',...
      'nn_gamma=eval(get(hhh(6),''String''));',...
      'nn_TFilter=eval(get(hhh(7),''String''));',...
      'keyModel=get(hhh(8),''Value'');',...
      'close(gcf); ',...
      'waitmsg(''Performing control, please wait...'');',...
      'clear nln_gpcx; pause(0.00001); ',...
      'if keyModel==2, ',...
         '[t,y,c,d,e]=nln_gpcx([nn_simpoints,nn_lambda,0,nn_umax,3,3,nn_gamma_n,10,0.1],',...
         '[bd_wt,card_out],[],[nn_ie50,6.9,nn_gamma,4.3],nn_TFilter);',...
      'else,',...
         'if bFitModel==0,',...
            'eval(get(mnuModel(9),''CallBack''));',...
         'end,',...
         'G_Fdbk=K_p+G_Kidneys+(G_Gut+K_l)*G_Liver+G_OtherVis+G_Muscle+G_Fat+G_Nasal+G_Brain;',...
         'G_Sys=feedback(G_Lungs,G_Fdbk,1)*K_Brain*G_Brain;',...
         'G_Sys=minreal(G_Sys,3e-4); zpk(G_Sys); ',...
         'num=G_Sys.num{1}; den=G_Sys.den{1};',...
         'ii=find(abs(num)>eps); num=num(ii(1):length(num));',...
         '[t,y,c,d,e]=nln_gpcx([nn_simpoints,nn_lambda,0,nn_umax,3,3,nn_gamma_n,10,0.1],',...
         'num,den,[nn_ie50,6.9,nn_gamma,4.3],nn_TFilter);',...
      'end,',...
      'pause(0.00001); delete(gcf); ',...
      'stairs(t,y(:,1:3))']);
         
