gEffWin=figure('Resize','off',...
   'Name','Please Enter Pharmacodynamic Parameters',...
   'NumberTitle','off',...
   'MenuBar','none',...
   'Position',[200,200,300,180]);

hh=axes('Position',[0.001,0.001,0.998,0.998]);
set(hh,'Visible','off');

%%  Define simulation parameters
text(0.05,0.80,'EC_{50} (ng ml^{-1})');

hhh(1)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.75 0.2 0.10],...
   'String',num2str(EC50),...
   'BackgroundColor',[1,1,1]);

text(0.05,0.60,'Steepness \gamma');

hhh(2)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.55 0.2 0.10],...
   'String',num2str(gam),...
   'BackgroundColor',[1,1,1]);

if bEffect==2
   text(0.05,0.40,'Value of E_{max} (Hz)');
   hhh(3)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.35 0.2 0.10],...
   'String',num2str(EMax),...
   'BackgroundColor',[1,1,1]);
   text(0.05,0.20,'Value of E_0 (Hz)');
   hhh(4)=uicontrol('Style','Edit',...
   'Unit','normalized',...
   'Position',[0.545 0.15 0.2 0.10],...
   'String',num2str(E0),...
   'BackgroundColor',[1,1,1]);
end

set(gcf,'UserData',hhh);

uicontrol('Style','PushButton',...
   'Unit','normalized',...
   'Position',[0.78,0.75,0.2,0.12],...
   'String','Effect',...
   'Back',[0.7529,0.7529,0.7529],...
   'CallBack',['h=get(gcf,''UserData'');',...
               'EC50=eval(get(hhh(1),''String''));',...
               'gam=eval(get(hhh(2),''String''));',...
               'if bEffect==2,',...
                  'EMax=eval(get(hhh(3),''String''));',...
                  'E0=eval(get(hhh(4),''String''));',...
               'end;',...   
               'close(gcf); ',...
               'eval(get(mnuModel(3),''CallBack'')); ',...
               'y_Alge=Brain(:,2)*336.6; ',...
               'y_Alge=y_Alge.^gam./(EC50^gam+y_Alge.^gam);',...
               'if bEffect==2, ',...
                  'y_Alge=E0-y_Alge*EMax;',...
               'end,',...
               'if bFitModel==0,',...
                  'bFitModel=2; eval(get(mnuModel(9),''CallBack'')); ',...
               'end,',...   
               '[t_Simu,x,y_Effect]=sim(''hig_dyna'',[0,nn_simend/60]);',...
               'y_Simu=y_Effect(:,bEffect);',...   
               'plot(t_Alge,y_Alge,t_Simu,y_Simu);']);
               
uicontrol('Style','PushButton',...
   'Unit','normalized',...
   'Position',[0.78,0.55,0.2,0.12],...
   'String','Cancel',...
   'Back',[0.7529,0.7529,0.7529],...
   'CallBack',['close(gcf);']);
