%shw_plot

%prepare data for drawing, when algebraic model is used
if bDispCur==1 | bDispCur==3
   if bAlgeModel==0, 
      clear higginsm;
      [nn,t_Alge,Lungs,Perip,Kidneys,GutSpleen,Liver,OtherVis,Muscle,Fat,...
          Nasal,Brain,ImSite,Metabolism,Excretion,ArtPool,VenPool,BldFrac]=...
      higginsm([nn_weight,nn_simend,nn_CalStep,nn_cardop,nn_FenDose,nn_DoseDur]);
      bAlgeModel=1; 
   end
   % no plasma concentration available, use blood concentration instead.
   if any([1:2,4:5,8:9]==bShwPlt) & bDispConc==3, bDispConc=2; end
   
   switch bShwPlt
      case 1
         y_Alge=Kidneys(:,bDispConc);
      case 2
         y_Alge=Liver(:,bDispConc);
      case 3
         y_Alge=GutSpleen(:,bDispConc);
      case 4
         y_Alge=OtherVis(:,bDispConc);
      case 5
         y_Alge=Muscle(:,bDispConc);
      case 6
         y_Alge=Fat(:,bDispConc);
      case 7
         y_Alge=Brain(:,bDispConc);
      case 8
         y_Alge=Nasal(:,bDispConc);
      case 9
         y_Alge=VenPool(:,bDispConc);
      case 10
         y_Alge=ArtPool(:,bDispConc);
      case 11
         y_Alge=Lungs(:,bDispConc);
   end   
   if bUnits==2, 
      y_Alge=y_Alge*336.6; 
      if bDispConc==1, y_Alge=y_Alge*1000; end
   end
   drw_array='(t_Alge,y_Alge)';
   if bDispCur==3, 
      drw_array='(t_Alge,y_Alge,t_Simu,y_Simu)'; 
   end
elseif bDispCur==2
   drw_array='(t_Simu,y_Simu)';
end   

aa=get(gcf,'Child');
bFigs=0;
for i=1:length(aa)
   if strcmp(get(aa(i),'Type'),'axes')
      bFigs=1; 
      x1=get(gca,'xgrid'); x2=get(gca,'box');
      break;
   end
end

%prepare data for drawing, when SIMULINK model is used
if bDispCur==2 | bDispCur==3
   if bFitModel==0
      bFitModel=2; eval(get(mnuModel(9),'CallBack')); 
   end   
   [t_Simu,x,MyOut]=sim('hig_simu0',[0,nn_simend/60]);
   if bShwPlt==11, 
      y_Simu=MyOut(:,11);
   else   
      y_Simu=MyOut(:,bShwPlt+1);
   end   
   if bDispConc==2 | bDispConc==3
      y_Simu=y_Simu*K_Opts(bShwPlt);
   end
   if bUnits==2, 
      y_Simu=y_Simu*336.6; 
   end
   ii=find(y_Simu>=0); 
   t_Simu=t_Simu(ii); y_Simu=y_Simu(ii);
end

if bAxisLog==0, 
   str1='plot'; 
elseif bAxisLog==1, 
   str1='loglog'; 
elseif bAxisLog==2, 
   str1='semilogx'; 
end

eval([str1, drw_array])

if bFigs==1, 
   set(gca,'xgrid',x1); set(gca,'ygrid',x1); set(gca,'box',x2);   
end   

%xlabel('Time (minute)')
str_title='Drug ';  
if bDispConc==1, 
   if bUnits==1, ylabel('\mumol');
   else, ylabel('\mug'); end
   str_t1='Amount from ';
else
   if bUnits==1, ylabel('\mumol g^{-1}');
   else, ylabel('ng g^{-1}'); end
   if bDispConc==2, 
      str_t1='Blood Concentration in ';
   elseif bDispConc==3, 
      str_t1='Plasma Concentration in ';
   end
end

switch bShwPlt
   case 1, str_t2='Kidneys';
   case 2, str_t2='Liver';
   case 3, str_t2='Gut Spleen';
   case 4, str_t2='Other Viscera';
   case 5, str_t2='Muscle';
   case 6, str_t2='Fat';
   case 7, str_t2='Brain';
   case 8, str_t2='Nasal';
   case 9, str_t2='Venous Pool';
   case 10, str_t2='Arterial Pool';
   case 11, str_t2='Lungs';
end   

title([str_title, str_t1, str_t2])

bFigExist=1;
