function [xL,h]=str_disp(x,y,Str1,nCol,vis,nFSize)
%ShwSupsc show strings with superscripts
%   [xL,h,h1]=ShwSupsc(x,y,Str1,StrSup,nCol,nDisp,vis)
%   where xL  is the x coordinate of the left end
%          when the string with superscript displayed
%     h, h1 are the handles of string and the 
%          superscript, respectively
%     x,y the atarting position of the strings
%     Str1, StrSup -- the contents of the string and 
%          superscript to be displayed, respectively
%     nCol is the color specification
%     nDisp is the displacement for the superscript
%          is a negative number given, then subscript 
%     vis is the visibility of the strings    

%to use with CtrlLAB
%  (c) Xue Dingy, 1996, 18 Dec, 1996
%   Dept of Automatic Control, 
%   Northeastern University, PR China
%   email: xued@ramm.neu.edu.cn
if nargin<6, nFSize=10; end
if nargin<5, vis='on'; end
if nargin<4, nCol=[1,1,1]; end
h=text(x,y,Str1); 
set(h,'FontName','Times New Roman',...
      'FontSize',nFSize,...
      'Color',nCol,...
      'Visible',vis);
xL1=get(h,'Extent'); 
xL=xL1(1)+xL1(3); 

